#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

struct salAndIndex
{
    int salary;
    int index;
};

bool compare(salAndIndex a, salAndIndex b)
{
    return a.salary < b.salary;
}

bool upSals(int *salaries, int n)
{
    bool changed = false;
    int salOrig[n];
    for (int i = 0; i < n; i++)
    {
        salOrig[i] = salaries[i];
    }
    int cToChangeIndex = n - 1, nextBiggerIndex;
    while (cToChangeIndex >= 0)
    {
        nextBiggerIndex = cToChangeIndex+1;
        while (nextBiggerIndex < n)
        {
            if (salaries[cToChangeIndex] < salOrig[nextBiggerIndex])
            {
                if (salOrig[nextBiggerIndex] - salaries[cToChangeIndex] > 1)
                {
                    salaries[cToChangeIndex] =
                        (salaries[cToChangeIndex] + salOrig[nextBiggerIndex]) / 2;
                    changed = true;
                }
                break;
            }
            nextBiggerIndex++;
        }


        cToChangeIndex--;
    }

    //true if changed, false if no change
    return changed;
}

bool statusIsKept(int *salaries, int n, salAndIndex sortedSalIndexes[], bool equalSalsIndexes[])
{
    bool statusKept = true;
    for (int i = 0; i < n-1; i++)
    {
        if (!((equalSalsIndexes[i]
                && salaries[sortedSalIndexes[i].index]
                == salaries[sortedSalIndexes[i+1].index])
                    || ((!equalSalsIndexes[i])
                            && salaries[sortedSalIndexes[i].index]
                                < salaries[sortedSalIndexes[i+1].index])))
        {
            statusKept = false;
            break;
        }
    }

    return statusKept;
}

void printSal(int *salaries, int n)
{
    for (int i = 0; i < n; i++)
    {
        cout << salaries[i] << endl;
    }
}

int main()
{
    int n;
    cin >> n;

    salAndIndex salToSort[n];
    bool equalSalsIndex[n-1];
    int salFinal[n];
    for (int i = 0; i < n; i++)
    {
        cin >> salFinal[i];
        salToSort[i].index = i;
        salToSort[i].salary = salFinal[i];
        equalSalsIndex[i] = false;
    }

    sort(salToSort, salToSort+n, compare);

    // write down equal salaries
    for (int i = 0; i < n-1; i++)
    {
        if (salFinal[salToSort[i].index] == salFinal[salToSort[i+1].index])
        {
            equalSalsIndex[i] = true;
        }
    }

    int lastCopy[n];

    for (int i = 0; i < 12; i++)
    {
        for (int j = 0; j < n; j++)
        {
            lastCopy[j] = salFinal[j];
        }
        if (upSals(salFinal, n))
        {
            //check if the status is kept
            if(!statusIsKept(salFinal, n, salToSort, equalSalsIndex))
            {
                // print last copy
                printSal(lastCopy, n);
                return 0;
            }
        }
        else
        {
            // if there is no changes
            break;
        }
    }

    printSal(salFinal, n);

    return 0;
}

/*

4
300
1090
400
1000


*/
