#include <iostream>
#include <vector>

using namespace std;


vector< int > NumberArray;
unsigned int N;

// [ Begin; End ] ( Inclusive )
int SumBetweenIndicies( unsigned int Begin, const unsigned int End )
{
    int Result = 0;

    while( Begin <= End )
    {
        Result += NumberArray[ Begin ];
        ++Begin;
    }

    return Result;
}

int LargestGroupedSum( const unsigned int GroupSize )
{
    int Result = SumBetweenIndicies( 0, GroupSize - 1 );

    unsigned int Index = 0; // Could be optimized but can't bother testing it again with limited time.
    const unsigned int EndPointIndex = N - GroupSize; // It is inclusive
    const unsigned int IndexOffset = GroupSize - 1;

    int GroupSum;
    while( Index <= EndPointIndex )
    {
        GroupSum = SumBetweenIndicies( Index, Index + IndexOffset );
        if( GroupSum > Result )
        {
            Result = GroupSum;
        }

        ++Index;
    }

    return Result;
}

int main()
{
    cin >> N;

    // NOTE: reserve function
    NumberArray.reserve( N );

    unsigned int InputNumber;
    for( unsigned int I = 0; I < N; ++I )
    {
        cin >> InputNumber;
        NumberArray.push_back( InputNumber );
    }


    int LargestFoundSum = NumberArray[ 0 ];    // No need to be a 64 bit integer

    int GroupSum;
    for( unsigned int I = 1; I <= N; ++I )
    {
        GroupSum = LargestGroupedSum( I );

        if( GroupSum > LargestFoundSum )
        {
            LargestFoundSum = GroupSum;
        }
    }

    cout << LargestFoundSum;
}
