#include<iostream>
#include "math.h"
#include<algorithm>
#include<vector>

int N;
int tRow;
int tCol;

using namespace std;

struct nprime {
	int num;
	int fact;
};

int primeFactors(int n) {
	if(n == 1) return 0;
	if(n == 2) return 1;

	int factors = 0;
	bool div2 = false;
	while (n % 2 == 0) {
		n = n/2;
		div2 = true;
	}
	if(div2) factors++;

	for (int i = 3; i <= sqrt((double)n); i = i+2) {
		bool div3 = false;
		while (n % i == 0) {
			n = n/i;
			div3 = true;
		}
		if(div3) factors++;
	}

	if (n > 2) {
		factors++;
	}
	return factors;
}

bool comparator(nprime const& n1, nprime const& n2) {
	return n1.fact < n2.fact && n1.num > n2.num;
}

int main() {
	cin >> N >> tRow >> tCol;
	
	int numsToPosition = tRow * N - (N - tCol);

	vector<nprime> vec;
	vec.reserve(N*N);

	for(int i = 0; i < N*N; i++) {
		int fct = primeFactors(i+1);
		nprime p;
		p.fact = fct;
		p.num = i+1;

		vec.push_back(p);
	}

	std::sort(vec.begin(), vec.end(), comparator);

	for(int k = 0; k < N*N; k++) {
		if(k+1 == numsToPosition) {
			cout<<vec[k].num<<endl;
			return 0;
		}
	}

	return 0;
}
