#include <iostream>
#include <algorithm>
#define MAXN 100000

using namespace std;

struct Employee {
  int index;
  int salary;
  int old_salary;
};

Employee employees[MAXN];
int n;

bool salary_cmp(const Employee &a, const Employee &b) {
  return a.salary < b.salary;
}

bool old_salary_cmp(const Employee &a, const Employee &b) {
  return a.old_salary < b.old_salary;
}

bool index_cmp(const Employee &a, const Employee &b) {
  return a.index < b.index;
}

bool check() {
  sort(employees, employees + n, old_salary_cmp);
  bool chk = false;
  int i;
  for(i=0; i<n-1; i++) {
    if(employees[i].salary > employees[i+1].salary) return false;
    else if(employees[i].salary == employees[i+1].salary && employees[i].old_salary != employees[i+1].old_salary) return false;

    if(!chk && employees[i].salary != employees[i].old_salary) chk = true;
  }

  return chk;
}

void iterate() {
  int i, j;
  for(i=0; i<n-1; i++) {
    for(j=i+1; j<n; j++) {
      if(employees[j].salary > employees[i].salary) {
        break;
      }
    }

    if(employees[j].salary > employees[i].salary) {
      employees[i].old_salary = employees[i].salary;
      employees[i].salary = (employees[i].salary + employees[j].salary) / 2;
    }
  }
}

int main() {
  cin >> n;

  int i, j;
  for(i=0; i<n; i++) {
    employees[i].index = i;
    cin >> employees[i].salary;
    employees[i].old_salary = employees[i].salary;
  }


  bool error = false;
  for(j=0; j<12; j++) {
    iterate();
    if(!check()) {
      error = true;
      break;
    }
    sort(employees, employees + n, index_cmp);
  }

  sort(employees, employees + n, index_cmp);

  if(error) {
    for(i=0; i<n; i++) {
      cout << employees[i].old_salary << endl;
    }
  } else {
    for(i=0; i<n; i++) {
      cout << employees[i].salary << endl;
    }
  }

  return 0;
}
