#include <iostream>
#include <cstdio>
#include <ctime>
#include <fstream>
using namespace std;

const int MAXN = 100005;
int n;
int curr = 0, last = 1;
int sal[2][MAXN];      // sal[i] - zaplatata na chovek i
int money[MAXN];    // money[i] - broi hora koito poluchavat zaplata i
int money2[MAXN];   // money2[i] - broi hora koito poluchavat zaplata po-malka ili ravna na i
int tapaci[MAXN];   // tapaci[i] - hora sas zaplata po-malko ot tazi na i
int next[MAXN];     // next[i] - nai-blizkiq chovek s po-golqma zaplata ot tazi na i

int main() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    time_t startt= time(NULL);
    scanf("%d", &n);
    for(int i = 0; i < n; i++) {
        scanf("%d", sal[curr]+i);
        money[sal[curr][i]]++;
    }

    // calc next
    for(int i = 0; i < n; i++) {
        next[i] = -1;
        for(int j = i+1; j < n; j++) {
            if(sal[curr][j] > sal[curr][i]) {
                next[i] = j;
                break;
            }
        }
        #ifdef DEBUG
        printf("%d ", next[i]);
        #endif
    }
    #ifdef DEBUG
    printf("\n");
    #endif

    // calc money2
    money2[0] = money[0];
    for(int i = 1; i < MAXN; i++) {
        money2[i] = money2[i-1] + money[i];
    }

    // calc tapaci
    for(int i = 0; i < n; i++) {
        tapaci[i] = money2[sal[curr][i]];
        #ifdef DEBUG
        printf("%d ", tapaci[i]);
        #endif
    }
    #ifdef DEBUG
    printf("\n");
    #endif

    // iterate
    bool change, balance;
    int t;
    for(int i = 0; i < 12; i++) {
        change = false;

        t = curr;
        curr = last;
        last = t;

        for(int j = 0; j < n; j++) {
            if(next[j] != -1) {
                sal[curr][j] = (sal[last][j] + sal[last][next[j]])/2;

                // update money
                money[sal[last][j]]--;
                money[sal[curr][j]]++;

                // update money2
                //for(int k = sal[last][j]; k < sal[curr][j]; k++) {
                //    money2[k]--;
                //}

                change = (sal[curr][j] != sal[last][j]);
            } else {
                sal[curr][j] = sal[last][j];
            }
        }

        #ifdef DEBUG
        for(int j = 0; j < n; j++) {
            printf("%d ", sal[curr][j]);
        }
        printf("\n");
        #endif

        if (!change) {
            break;
        }


        // check balance
        // calc money2
        money2[0] = money[0];
        for(int i = 1; i < MAXN; i++) {
            money2[i] = money2[i-1] + money[i];
        }
        balance = true;
        for(int i = 0; i < n; i++) {
            if(tapaci[i] != money2[sal[curr][i]]) {
                balance = false;
            }
        }
        if(!balance) {
            t = curr;
            curr = last;
            last = t;
            break;
        }
    }



    for(int j = 0; j < n; j++) {
        printf("%d\n", sal[curr][j]);
    }

      #ifdef DEBUG
      time_t endt= time(NULL);
    printf("%f\n", (double) (difftime(endt, startt)));
    #endif


    return 0;
}

