#include <cstdio>
#include <algorithm>
//#include <ctime>

using namespace std;

#define MAXN 100000

int ar[MAXN],N;
int order[MAXN],p[MAXN];
bool equalToPrevious[MAXN];

bool compare(int a, int b) { return (ar[a] < ar[b]); }

void initOrder()
{
	for(int i=0; i<N; i++) order[i]=i;
	sort(order,order+N,compare);
	for(int i=1; i<N; i++) if(ar[order[i]]==ar[order[i-1]]) equalToPrevious[i]=true;
}
void initP()
{
	int st[MAXN],stn=0;
	for(int i=N-1; i>=0; i--)
	{
		p[i]=-1;
		while(stn and ar[st[stn-1]]<=ar[i]) stn--;
		if(stn) p[i]=st[stn-1];
		st[stn]=i; stn++;
	}
}

int t[MAXN];

//time_t lastTime;

void solve()
{
	for(int it=1; it<=12; it++)
	{
		for(int i=0; i<N; i++) t[i] = (p[i]==-1) ? ar[i] : (ar[i]+ar[p[i]])/2;
		//printf("roar\n");
		//for(int i=0; i<N; i++) printf("%d ", t[i]); printf("\n");
		bool hasChanged=(t[0]!=ar[0]);
		for(int i=1; i<N; i++)
		{
			//printf("%d %d\n", t[order[i]], t[order[i-1]]);
			if((equalToPrevious[i] and t[order[i]] != t[order[i-1]]) or (!equalToPrevious[i] and t[order[i]] <= t[order[i-1]])) return;
			if(t[i] != ar[i]) hasChanged=true;
		}
		if(!hasChanged) return;
		//printf("roar\n");
		for(int i=0; i<N; i++) ar[i]=t[i];
	}
}

void print()
{
	for(int i=0; i<N; i++) printf("%d\n", ar[i]);
}


int main()
{
	//O(NlogN)
	//lastTime = clock();
	
	if(true)
	{
		scanf("%d", &N);
		for(int i=0; i<N; i++) scanf("%d", &ar[i]);
	}
	else
	{
		N=100000;
		for(int i=0; i<N; i++) ar[i]=300+i;
	}
	
	initOrder(); //printf("1: %f\n", (float)(clock()-lastTime)/1000); lastTime=clock();
	initP(); //printf("2: %f\n", (float)(clock()-lastTime)/1000); lastTime=clock();
	//for(int i=0; i<N; i++) printf("%d ", ar[order[i]]); printf("\n");
	
	//for(int i=0; i<N; i++) printf("%d ", ar[order[i]]); printf("\n");
	//for(int i=0; i<N; i++) printf("%c ", equalToPrevious[i] ? 'Y' : 'N'); printf("\n");
	
	//for(int i=0; i<N; i++) printf("%d(%d)\n", ar[i], p[i]!=-1 ? ar[p[i]] : -1);
	
	solve();
	//printf("3: %f\n", (float)(clock()-lastTime)/1000); lastTime=clock();
	//freopen("salaries.txt", "w", stdout);
	print();
	//freopen("salaries_time.txt", "w", stdout);
	//printf("4: %f\n", (float)(clock()-lastTime)/1000); lastTime=clock();
	
	return 0;
}
