#include <stdio.h>

using namespace std;

unsigned long long salaries[100000], newSalaries[100000];
int n, currentSalariesHirarchy[100000];

void ChangeSalaries()
{
	for (int i = 0; i < n; i++) salaries[i] = newSalaries[i];
}

bool FindFirstGreater(int current_pos, int &larger_pos)
{
	for (int i = current_pos + 1; i < n; i++)
		if (salaries[i] > salaries[current_pos])
		{
			larger_pos = i;
			return true;
		}
	return false;
}

bool HirarchyKept()
{
	for (int i = n - 2; i >= 0; i--)
	{
		int hirarchyCoeff = 0;
		for (int j = i + 1; j < n; j++)
			if (newSalaries[i] > newSalaries[j]) hirarchyCoeff++;
		if (hirarchyCoeff != currentSalariesHirarchy[i]) return false;
	}
	ChangeSalaries();
	return true;
}

bool CalculateNewSalaries()
{
	bool HasChanged = false;
	for (int i = 0; i < n; i++)
	{
		int firstGreater = -1;
		if (FindFirstGreater(i, firstGreater))
		{
			HasChanged = true;
			newSalaries[i] = (salaries[i] + salaries[firstGreater]) / 2;
		}
		else newSalaries[i] = salaries[i];
	}
	if (!HasChanged) return false;
	else return HirarchyKept();
}

void CalculateHirarchy()
{
	for (int i = 0; i < n - 1; i++)
		for (int j = i + 1; j < n; j++)
			if (salaries[i] > salaries[j])
				currentSalariesHirarchy[i]++;
}

int main()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++) scanf("%llu", &salaries[i]);
	CalculateHirarchy();
	for (int i = 0; i < 12; i++)
		if(CalculateNewSalaries() == false) i = 12;
	for (int i = 0; i < n; i++) printf("%llu\n", salaries[i]);
	return 0;
}
