#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <queue>

using namespace std;

const int maxCapacity = 20000;

int PRIME_NUMBERS[maxCapacity];
int index = 0;

void FindAllPrimeNumbers()
{
    // Finds all primers numbers in range [1, 1000]
    for (int i = 2; index < maxCapacity; i++)
    {
        bool isPrime = true;

        for (int j = 2; j <= sqrt(i); j++)
        {
            if (i % j == 0)
            {
                isPrime = false;
                break;
            }
        }

        if (isPrime)
        {
            PRIME_NUMBERS[index++] = i;
        }
    }
}

int FindNumberOfDividers(int number)
{
    int numberOfDividers = 0;

    if (number == 1) {
        return 1;
    }

    for (int i = 0; i < maxCapacity; i++) {
        if (PRIME_NUMBERS[i] > number) break;

        if (number % PRIME_NUMBERS[i] == 0) {
            numberOfDividers++;
        }
    }

    return numberOfDividers;
}

int main()
{
    FindAllPrimeNumbers();

    int N, r, c;

    cin >> N >> r >> c;

    r -= 1; c -= 1;

    //int matrix[N][N];
    queue<int> numbers;

    for (int i = 1; i <= N * N; i++) {
        numbers.push(i);
    }


    int dividers = 1;

    // Fill the matrix
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            int index = 0;
            bool found = false;

            while (!found) {
              if (index  == numbers.size()) {
                    dividers++;
                    index = 0;
                    continue;
                }

                int k = numbers.front();
                int d = FindNumberOfDividers(k);

                if (d == dividers) {
                    numbers.pop();
                    //matrix[i][j] = k;
                    found = true;

                    if (i == r && j == c)
                    {
                        cout << k;
                        return 0;
                    }
                }
                else {
                    numbers.pop();
                    numbers.push(k);
                }

                index++;
            }
        }
    }

//    cout << matrix[r][c];

    return 0;
}
