#include <iostream>
#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>

#define pb push_back
#define mp make_pair

using namespace std;

typedef pair<int, int> PII;

const int MAXN = 100100;

int n, a[MAXN], b[MAXN];
int pw[MAXN];
int rmq[MAXN][20];
int nxt[MAXN];
vector< vector<int> > status;

void read() {
    scanf("%d", &n);
    for(int i = 0; i < n; i ++)
        scanf("%d", &a[i]);
}

int getMax(int le, int ri) {
    if(le > ri) return 0;
    int len = (ri - le + 1);
    return max(rmq[le][ pw[len] ], rmq[ ri - (1 << pw[len]) + 1 ][ pw[len] ]);
}

void findStatus() {
    vector< PII > vec;
    vector<int> tmp;

    for(int i = 0; i < n; i ++)
        vec.pb(mp(a[i], i));

    sort(vec.begin(), vec.end());

    tmp.pb(vec[0].second);
    for(int i = 1; i < vec.size(); i ++) {
        if(vec[i].first != vec[i - 1].first) {
            status.pb(tmp);
            tmp.clear();
        }

        tmp.pb(vec[i].second);
    }

    status.pb(tmp);
}

bool checkStatus() {
    vector< vector<int> > _status;
    vector< PII > vec;
    vector<int> tmp;

    for(int i = 0; i < n; i ++)
        vec.pb(mp(b[i], i));

    sort(vec.begin(), vec.end());

    tmp.pb(vec[0].second);
    for(int i = 1; i < vec.size(); i ++) {
        if(vec[i].first != vec[i - 1].first) {
            _status.pb(tmp);
            tmp.clear();
        }

        tmp.pb(vec[i].second);
    }

    _status.pb(tmp);

    return status == _status;
}

void init() {
    for(int i = 0; i < n; i ++)
        rmq[i][0] = a[i];

    for(int p = 1; (1 << p) <= n; p ++)
        for(int i = 0; i + (1 << p) - 1 < n; i ++)
            rmq[i][p] = max(rmq[i][p - 1], rmq[ i + (1 << (p - 1)) ][p - 1]);

    pw[1] = 0;
    for(int i = 2; i <= n; i ++)
        pw[i] = pw[i >> 1] + 1;

    memset(nxt, -1, sizeof(nxt));
    for(int i = 0; i < n; i ++) {
        if(a[i] > getMax(i + 1, n - 1)) continue;
        int le = i + 1, ri = n - 1, mid;
        while(le <= ri) {
            mid = (le + ri) >> 1;
            if(a[i] < getMax(i + 1, mid - 1)) ri = mid - 1;
            else if(a[i] < a[mid]) {
                nxt[i] = mid;
                break;
            }
            else le = mid + 1;
        }
    }

    findStatus();
}

void buildB() {
    for(int i = 0; i < n; i ++)
        if(nxt[i] == -1) b[i] = a[i];
        else b[i] = (a[i] + a[ nxt[i] ]) / 2;
}

bool same() {
    for(int i = 0; i < n; i ++)
        if(a[i] != b[i])
            return false;
    return true;
}

bool check() {
    return (!same() && checkStatus());
}

void write() {
    for(int i = 0; i < n; i ++)
        printf("%d\n", a[i]);
}

void solve() {
    for(int iter = 0; iter < 12; iter ++) {
        buildB();
        if(!check()) {
            write();
            return;
        }
        memcpy(a, b, sizeof(b));
    }
    write();
}

int main()
{
    read();
    init();
    solve();

    return 0;
}
