/**
Contest: NOI 2014, Round 2
Task: A1.salaries
Nikola Stoyanov
29.03.2014, Varna
*/

#include <cstdio>
//#include <cstdlib>
#include <stack>
#include <algorithm>

struct WorkWork
{
	WorkWork ()
		: salary (0), indNext (-1)
	{
	}

	int salary;
	int indNext;
};

void input ();
void iteration ();
bool checkOrder ();
bool cmpOrder (int a, int b);

int nWorkers;
WorkWork* worker;
int* answ;
int* order;

int main ()
{
	input ();

	//if (nWorkers < 50000)
	//{
		for (int i=0; i < 12; i++)
		{
			for (int j=0; j < nWorkers; j++)
			{
				answ[j] = worker[j].salary;
			}

			iteration ();

			if (!checkOrder())
				break;
		}


		for (int i=0; i < nWorkers; i++)
		{
			printf ("%d\n", answ[i]);
		}
	//}
	/*else
	{
		srand (nWorkers);
		int iter = rand() % 6;

		for (int i=0; i < iter; i++)
			iteration ();

		for (int i=0; i < nWorkers; i++)
		{
			printf ("%d\n", worker[i].salary);
		}
	}*/

	delete[] worker;
	delete[] answ;
	return 0;
}

void input ()
{
	scanf ("%d", &nWorkers);
	worker = new WorkWork[nWorkers];
	answ = new int[nWorkers];

	std::stack<WorkWork*> poor;
	for (int i=0; i < nWorkers; i++)
	{
		scanf ("%d", &(worker[i].salary));
		while (!poor.empty() && poor.top()->salary < worker[i].salary)
		{
			poor.top()->indNext = i;
			poor.pop();
		}
		poor.push (worker + i);
	}

	order = new int[nWorkers];
	for (int i=0; i < nWorkers; i++)
	{
		order[i] = i;
	}
	std::sort (order, order + nWorkers, cmpOrder);
}

void iteration ()
{
	for (int i=0; i < nWorkers; i++)
	{
		if (worker[i].indNext != -1)
			worker[i].salary = (worker[worker[i].indNext].salary + worker[i].salary) >> 1;
	}
}

bool checkOrder()
{
	bool ret = true;
	int* newOrder = new int[nWorkers];
	for (int i=0; i < nWorkers; i++)
	{
		newOrder[i] = i;
	}
	std::sort (newOrder, newOrder + nWorkers, cmpOrder);

	for (int i=0; i < nWorkers; i++)
	{
		if (order[i] != newOrder[i] && worker[order[i]].salary != worker[newOrder[i]].salary)
		{
			ret = false;
			break;
		}
	}

	delete[] newOrder;
	return ret;
}

bool cmpOrder (int a, int b)
{
	return worker[a].salary < worker[b].salary;
}

/*
4
300 1090 400 1000
*/
