/**
Tournament: National olympiad in informatics 2014, Round 2
Task: A1 - salaries - Dummy :<
Language: C/C++
Author: Vasil Sarafov
29.03.2014, Varna
**/
#include <iostream>
#include <set>
#include <vector>
#include <cstdio>
#define space " "
#define ln "\n";
using namespace std;

typedef set <int>::iterator Iterator;

const int MAXN = (int)(1e5) + 10;

int n;
int a[MAXN], b[MAXN];
set <int> even[MAXN];
set <int> bigger[MAXN];

void printArray(int arr[]);

int main(void)
{
    // reading input
    scanf("%d", &n);
    for(int i = 1; i <= n; i++) scanf("%d", &a[i]);

    // compute status of the salaries
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            if(a[i] == a[j]) even[i].insert(j);
            if(a[i] < a[j]) bigger[i].insert(j);
        }
    }

    // start iteration with a very low constant
    for(int it = 1; it <= 12; it ++)
    {
        if(it & 1) // working with b array
        {
            // update salaries in array b
            for(int i = 1; i <= n; i++)
            {
                for(int j = i + 1; j <= n; j++)
                {
                    if(a[i] < a[j])
                    {
                        b[i] = (a[i] + a[j]) / 2;
                        break;
                    }
                    b[i] = a[i];
                }
            }
            b[n] = a[n];

            // check new salaries in array b, if bad print array a
            for(int i = 1; i <= n; i++)
            {
                for(int j = 1; j <= n; j ++)
                {
                    if(b[i] == b[j])
                    {
                        Iterator index = even[i].find(j);
                        if(index == even[i].end())
                        {
                            printArray(a);
                            return 0;
                        }
                    }

                    if(b[i] < b[j])
                    {
                        Iterator index = bigger[i].find(j);
                        if(index == bigger[i].end())
                        {
                            printArray(a);
                            return 0;
                        }
                    }
                }
            }
        }
        else // working with a array
        {
            // update salaries in array a
            for(int i = 1; i <= n; i++)
            {
                for(int j = i + 1; j <= n; j++)
                {
                    if(b[i] < b[j])
                    {
                        a[i] = (b[i] + b[j]) / 2;
                        break;
                    }
                    a[i] = b[i];
                }
            }
            a[n] = b[n];

            // check new salaries in array a, if bad print array b
            for(int i = 1; i <= n; i ++)
            {
                for(int j = 1; j <= n; j++)
                {
                    if(a[i] == a[j])
                    {
                        Iterator index = even[i].find(j);
                        if(index == even[i].end())
                        {
                            printArray(b);
                            return 0;
                        }
                    }

                    if(a[i] < a[j])
                    {
                        Iterator index = bigger[i].find(j);
                        if(index == bigger[i].end())
                        {
                            printArray(b);
                            return 0;
                        }
                    }
                }
            }
        }
    }

     printArray(a);

    return 0;
}


void printArray(int arr[])
{
    for(int i = 1; i <= n; i++)
        printf("%d\n", arr[i]);

    return;
}

/**
4
300
1090
400
1000
**/
