/**
Tournament: National olympiad in informatics 2014, Round 2
Task: A3 - Tab - Dummy :<
Language: C/C++
Author: Vasil Sarafov
29.03.2014, Varna
**/
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#define space " "
#define ln "\n";
using namespace std;

const int MAXN = (int)( 1 << 10 );
const int MAXK = 10;

int ma3x[MAXN][MAXN];
int n, r, c;
vector <int> vec[MAXK];
vector <int> primes;
bool used[MAXN*MAXN];

int getMulties(int num);
void precomputePrimes();

int main(void)
{
    // reading input
    scanf("%d", &n);
    scanf("%d %d", &r, &c);

    if(r == 1 && c == 1)
    {
        printf("1\n");
        return 0;
    }

    // decompose all numbers and differentiate them
    vec[1].push_back(1);
    precomputePrimes();
    for(int i = 2; i <= n*n; i ++)
    {
        int primeMults = getMulties(i);
        vec[primeMults].push_back(i);
    }

    // put numbers in ma3x
    int currentKind = 1, currentNumber = 0;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j ++)
        {
            if(currentNumber >= (int)(vec[currentKind].size()))
            {
                currentNumber = 0;
                currentKind ++;
            }

            ma3x[i][j] = vec[currentKind][currentNumber];
            currentNumber ++;

            if(i == r && j == c)
            {
                printf("%d\n", ma3x[r][c]);
                return 0;
            }
        }
    }

    return 0;
}

void precomputePrimes()
{
    int bound = n*n;

    for(int i = 2; i <= bound; i ++)
    {
        if(!used[i])
        {
            primes.push_back(i);
            for(int j = i; j <= bound; j += i) used[j] = true;
        }
    }

    return;
}

int getMulties(int num)
{
    set <int> ret;

    for(int i = 0; num != 1; i ++)
    {
        if(num % primes[i] == 0) ret.insert(primes[i]);
        while(num % primes[i] == 0 && num != 1) num /= primes[i];
    }

    return (int)(ret.size());
}

