#include <cstdio>

using namespace std;

class Bitmask
{
	public:
	long long arr[40];

	int len;

	bool get(int index)
	{
		int bIndex = index/64;
		int sIndex = index%64;
		return arr[bIndex]&(1<<sIndex);
	}

	void set(int index)
	{
		int bIndex = index/64;
		int sIndex = index%64;
		if(index>=len)len=index+1;
		arr[bIndex]|=1<<sIndex;
	}

	void merge(Bitmask* bm)
	{
		if((bm->len)>len) len = bm->len;
		else bm->len=len;
		for(int i = 0; i < len; i++)
		{
			arr[i]|=bm->arr[i];
		}
	}

	void init()
	{
		for(int i = 0; i < 40; i++) arr[i]=0;
		len=0;
	}
};

int main()
{
	int n,m;

	//cin>>m>>n;
	scanf("%i %i", &m, &n);
	//Bitmask* races = new Bitmask[m];
	Bitmask races[2001];
	for(int i = 0; i < n; i++) races[i].init();

	bool** match = new bool*[m];
	for(int i = 0; i < m; i++) match[i]=new bool[m];
	for(int i = 0; i < m; i++)
	{
		for(int j = 0; j < m; j++)
		{
			match[i][j]=false;
		}
	}

	//printf("You cant crash here\n");

	for(int i = 0; i < m; i++)
	{
		//cout<<"i = "<<i<<endl;
		int b;
		//cin>>b;
		scanf("%i",&b);
		//cout<<"No crash in INPUT of b???\n";
		for(int j = 0; j < b; j++)
		{
			int s;
			//cin>>s;
			scanf("%i", &s);
			s-=1;
			races[i].set(s);
			//cout<<"No crash in INPUT???\n";
		}
		//cout<<"No crash in sector -1\n";
		//system("pause");

		if(i>0)
		{
			for(int k = i-1; k >= 0; k--)
			{
				if(match[i][k]) continue;
				//cout<<"No crash in sector 1\n";
				int l = races[i].len;
				if(races[k].len<l)l=races[k].len;
				for(int j = 0; j < l; j++)
				{
					if(races[i].get(j) and races[k].get(j))
					{
						//cout<<"No crash on match!\n";
						match[i][k]=true;
						for(int w = 0; w < k; w++)
						{
							if(match[k][w]) match[i][w]=true;
						}

						break;
					}
				}
			}
		}

	}

	//printf("Dont crash!\n");

	for(int i = m-1; i >= 1; i--)
	{
		for(int j = 0; j < i; j++)
		{
			if(match[i][j])
			{
				races[j].merge(&races[i]);
			}
		}
	}

	//printf("Are you here?!??\n");

	int* passing = new int[n];
	//int passing[n];
	int index = 0;

	//printf("Or maybe here??");

	bool first = true;
	for(int i = 0; i < n; i++)
	{
		bool pass = true;
		for(int j = 0; j < m; j++)
		{
			if(races[j].get(i)==false or i>races[j].len)
			{
				pass=false;
				break;
			}
		}
		if(pass)
		{
			//printf("Added %i \n", i);
			passing[index]=i;
			index++;
		}
	}

	//cout<<index<<endl;
	printf("%i\n", index);
	for(int i = 0; i < index; i++)
	{
		if(i!=0) printf(" %i", passing[i]+1);
		else printf("%i", passing[i]+1);
	}
	//cout<<"Done!";

	//delete[] passing;
	//delete[] races;
	return 0;
}
