#include <iostream>
#define MAX_GRID 128

using namespace std;

bool grid[MAX_GRID][MAX_GRID];
int height, width;

/**
    spreads the virus from a cell
    @param x @param y coordinates of the cell
*/
void spread(int x, int y)
{
    grid[x][y] = true;

    if((x > 0) && (!grid[x-1][y])) spread(x-1, y);
    if((x < width - 1) && (!grid[x+1][y])) spread(x+1, y);
    if((y > 0) && (!grid[x][y-1])) spread(x, y-1);
    if((y < height - 1) && (!grid[x][y+1])) spread(x, y+1);
}

int main()
{
    int protectedCells, virusesNeeded = 0;
    cin >> height >> width;
    cin >> protectedCells;

    for(int i=0;i < protectedCells;i++)
    {
        int cellX, cellY;
        cin >> cellY >> cellX;
        grid[cellX-1][cellY-1] = true;
    }
    for(int x=0;x < width;x++)
    {
        for(int y=0;y < height;y++)
        {
            if(!grid[x][y])
            {
                //cout << x << " " << y << endl;
                spread(x, y);
                virusesNeeded++;
            }
        }
    }
    cout << virusesNeeded << endl;
    return 0;
}
/*
4 5
3 1 3 2 1 2 2
*/
