#include <string>
#include <iostream>
#include <iomanip>
#include <cmath>


class Prime_Matrix
{
	  static void Main();

  private:
	  static int ReadInput();

	  static bool Prime(int num);

	  static int FindNextPrime(int startNumber);

	  static void PrintMatrix(int d);
};

void Prime_Matrix::Main()
{
	  int n = ReadInput();
	  PrintMatrix(n);
}

int Prime_Matrix::ReadInput()
{
	  std::cout << std::wstring(L"N = ");
	  std::wstring input;
	  std::getline(std::cin, input);
	  int n = static_cast<int>(input);
	  return n;
}

bool Prime_Matrix::Prime(int num)
{
	  if (num == 2)
	  {
			return true;
	  }
	  if (num % 2 == 0)
	  {
			return false;
	  }

	  int maxDivider = static_cast<int>(sqrt(num));
	  for (int divider = 3; divider <= maxDivider; divider += 2)
	  {
			if (num % divider == 0)
			{
				  return false;
			}
	  }
	  return true;
}

int Prime_Matrix::FindNextPrime(int startNumber)
{
	  int num = startNumber;
	  while (!Prime(num))
	  {
			num++;
	  }
	  return num;
}

void Prime_Matrix::PrintMatrix(int d)
{
	  int lastPrime = 1;
	  for (int r = 0; r < d; r++)
	  {
			for (int c = 0; c < d; c++)
			{
				  int nextPrime = FindNextPrime(lastPrime + 1);
				  std::cout << std::setw(4) << nextPrime;
				  lastPrime = nextPrime;
			}
			std::cout << std::endl;
	  }
}

