#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

vector<int> primeNums;
set<int> primeNumsAndPowers;
set<int> otherNums;


void findPrimeNumsAndPowers(int n)
{
    const int N = n;
    bool eratosten[N];
    int br = 0, power;
 
    for(unsigned i=0; i<n; i++)
        eratosten[i] = 1;
    for(unsigned i=2; i<n; i++)
    {
        if(eratosten[i])
        {
            for(unsigned j=i; i*j < n; j++)
                eratosten[i*j] = 0;
        }
    }
 
    primeNums.push_back(1);
    primeNumsAndPowers.insert(1);
 
 
   for(unsigned i=2; i<n; i++)
    {
        if(eratosten[i])
        {
            primeNums.push_back(i);
            primeNumsAndPowers.insert(i);
            
            power = i*i;
            
            while(power <= n)
            {
                primeNumsAndPowers.insert(power);
                power = power*i; 
            }
            
        }
        
    }       
}



int main()
{
    int n;
    cin>>n;
    primeNums.resize(n*n);
    
    int r, c, numPos;
    cin>>r>>c;
    numPos = (r-1)*5 + c;
    
    findPrimeNumsAndPowers(n*n);    
    
    if(primeNumsAndPowers.size() >= numPos)
    {
         int counter = 1;
         for(set<int>::iterator i = primeNumsAndPowers.begin(); i != primeNumsAndPowers.end(); i++)
         {
             if(numPos == counter)
                {
                       cout<<*i<<endl;
                       return 0;
                }
             counter++;
         }
    }
   
    return 0;
}
